// File: VarArgsOverloads.java
//
// Demonstrate use of varargs combined with overloaded methods
// Show that a varargs parameter is just like an array

public class VarArgsOverloads {

	VarArgsOverloads() {
        vaTest(1, 2, 3);           // OK
        vaTest(10, 20, 30, 40);    // OK
        System.out.println();
        vaTest(true);              // OK
        vaTest(true, false, true); // OK
        //vaTest();                // Error: Ambiguous call!
        System.out.println();
	}

    void vaTest(int... v) {
        System.out.print("vaTest(int ...)  -  " + "Number of args: " + v.length + "    Contents: ");
		for (int n : v)
            System.out.print(n + " ");
        System.out.print("\nShow that varargs parameter v is just like an array:  ");
        for (int i = 0; i < v.length; i++)
        	System.out.print(v[i] + " ");
	    System.out.println();
    }

    void vaTest(boolean... v) {
        System.out.print("vaTest(boolean ...)   -  " + "Number of args: " + v.length + "    Contents: ");
		for (boolean b : v)
            System.out.print(b + " ");
        System.out.println();
    }

    public static void main(String[] args) {
	    new VarArgsOverloads();
    }

}

/* ========== Output ==========

vaTest(int ...)  -  Number of args: 3    Contents: 1 2 3 
Show that varargs parameter v is just like an array:  1 2 3 
vaTest(int ...)  -  Number of args: 4    Contents: 10 20 30 40 
Show that varargs parameter v is just like an array:  10 20 30 40 

vaTest(boolean ...)   -  Number of args: 1    Contents: true 
vaTest(boolean ...)   -  Number of args: 3    Contents: true false true 

=============================== */
